<?php
namespace app\admin\controller;

use app\BaseController;
use think\facade\Db;
use think\facade\View;

class Common extends BaseController
{
    public function initialize()
    {

         
        if(!file_exists(__DIR__ . '/../../../install/install.lock')==true){
            header('Location: /installs');
            exit;
        }

        //记录当天访问ip
        $ip=$_SERVER['REMOTE_ADDR'];
        
        // 获取用户浏览器
        $userAgent = $_SERVER['HTTP_USER_AGENT'];
        $browser = $this->getBrowser($userAgent);
        
        // 获取操作系统信息
        $os = $this->getOS($userAgent);

        // 判断当前是电脑还是手机访问
        $deviceType = $this->getDeviceType($userAgent);

        $data = [
            'time' => date("Y-m-d H:i:s"),
            'ip' => $ip,
            'browser' => $browser,
            'os' => $os,
            'device_type' => $deviceType
        ];
        
        // 查询当天数据
        $startOfDay = date("Y-m-d 00:00:00");
        $endOfDay = date("Y-m-d 23:59:59");
        $date = Db::name('count')->where('ip', $ip)->whereBetweenTime('time', $startOfDay, $endOfDay)->find();
        if ($date == null) {
            Db::name('count')->insert($data);
        }

        $adname =session('adname');
        if($adname==null){
            echo '<script>window.location.href="/admin/login"</script>';
        };

        $model=Db::name('model')->where('status',1)->order('sort asc,id asc')->select();
        

        View::assign([
            
            'adname'=>$adname,
            'model'=>$model,
        ]);
    }

    // 获取浏览器信息
    private function getBrowser($userAgent)
    {
        if (strpos($userAgent, 'MSIE') !== false || strpos($userAgent, 'Trident') !== false) {
            return 'Internet Explorer';
        } elseif (strpos($userAgent, 'Firefox') !== false) {
            return 'Firefox';
        } elseif (strpos($userAgent, 'Chrome') !== false) {
            return 'Chrome';
        } elseif (strpos($userAgent, 'Safari') !== false) {
            return 'Safari';
        } elseif (strpos($userAgent, 'Opera') !== false || strpos($userAgent, 'OPR') !== false) {
            return 'Opera';
        } else {
            return 'Other';
        }
    }

    // 获取操作系统信息
    private function getOS($userAgent)
    {
        if (preg_match('/Windows NT 10.0/i', $userAgent)) {
            return 'Windows 10';
        } elseif (preg_match('/Windows NT 6.3/i', $userAgent)) {
            return 'Windows 8.1';
        } elseif (preg_match('/Windows NT 6.2/i', $userAgent)) {
            return 'Windows 8';
        } elseif (preg_match('/Windows NT 6.1/i', $userAgent)) {
            return 'Windows 7';
        } elseif (preg_match('/Windows NT 6.0/i', $userAgent)) {
            return 'Windows Vista';
        } elseif (preg_match('/Windows NT 5.1/i', $userAgent)) {
            return 'Windows XP';
        } elseif (preg_match('/Mac OS X/i', $userAgent)) {
            return 'Mac OS X';
        } elseif (preg_match('/Linux/i', $userAgent)) {
            return 'Linux';
        } elseif (preg_match('/iPhone/i', $userAgent)) {
            return 'iPhone';
        } elseif (preg_match('/iPad/i', $userAgent)) {
            return 'iPad';
        } elseif (preg_match('/Android/i', $userAgent)) {
            return 'Android';
        } else {
            return 'Other';
        }
    }

    // 判断当前是电脑还是手机访问
    private function getDeviceType($userAgent)
    {
        if (preg_match('/Mobile|Android|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i', $userAgent)) {
            return '手机';
        } else {
            return '电脑';
        }
    }
}