<?php
namespace app\index\controller;

use app\BaseController;
use think\Request;
use think\facade\Db;
use think\facade\View;

class Common extends BaseController
{
    public function initialize()
    {       

       
        if(!file_exists(__DIR__ . '/../../../install/install.lock')==true){
            header('Location: /installs');
            exit;
        }
        
        // 配置参数
        $config = Db::name('config')->where('id', 1)->find();

        // 检查网站状态
        if (isset($config['status']) && $config['status'] == '0') {
            // 网站关闭，显示关闭提示
            echo isset($config['close_site_note']) ? $config['close_site_note'] : '网站已关闭';
            exit;
        }

        // 站点信息
        $system=Db::name('system')->where('id',1)->find();
        $long=Db::name('system')->where('id',1)->find();
        
        // 自定义标签 多维数组转换一维数组 
        $res=Db::name('label')->order('id asc')->select()->toArray(); 
        $label = array_column($res,'value','name');
        
        // 当前栏目下有多少个产品
        $cate = Db::name('category')->where('pid', '-1')->select()->toArray();
        foreach ($cate as $k => $v) {
            $totalCount = 0;
            $cate_pid = Db::name('category')->where('pid', $v['id'])->select()->toArray();
            foreach ($cate_pid as $ks => $vs) {
                $subTotalCount = 0;
                $cate_pid_pid = Db::name('category')->where('pid', $vs['id'])->select()->toArray();
                foreach ($cate_pid_pid as $ks2 => $vs2) {
                    $count = Db::name('content')->where('status', 1)->where('scode', $vs2['id'])->count();
                    Db::name('category')->where('id', $vs2['id'])->update(['count' => $count]);
                    $subTotalCount += $count;
                }
                $count = Db::name('content')->where('status', 1)->where('scode', $vs['id'])->count();
                $subTotalCount += $count;
                Db::name('category')->where('id', $vs['id'])->update(['count' => $subTotalCount]);
                $totalCount += $subTotalCount;
            }
            $count = Db::name('content')->where('status', 1)->where('scode', $v['id'])->count();
            $totalCount += $count;
            Db::name('category')->where('id', $v['id'])->update(['count' => $totalCount]);
        }



        // 记录当天访问ip
        $ip=$_SERVER['REMOTE_ADDR'];
        
        // 获取用户浏览器
        $userAgent = $_SERVER['HTTP_USER_AGENT'];
        $browser = $this->getBrowser($userAgent);
        
        // 获取操作系统信息
        $os = $this->getOS($userAgent);

        // 判断当前是电脑还是手机访问
        $deviceType = $this->getDeviceType($userAgent);

        $data = [
            'time' => date("Y-m-d H:i:s"),
            'ip' => $ip,
            'browser' => $browser,
            'os' => $os,
            'device_type' => $deviceType
        ];
        
        // 查询当天数据
        $startOfDay = date("Y-m-d 00:00:00");
        $endOfDay = date("Y-m-d 23:59:59");
        $date = Db::name('count')->where('ip', $ip)->whereBetweenTime('time', $startOfDay, $endOfDay)->find();
        if ($date == null) {
            Db::name('count')->insert($data);
        }
        
       
        // 栏目分类打印、支持无限极分类
        $category = $this->getCategoryTree(-1);

        // 增加导航is_dow字段，判断当前主分类下是否有子分类
        Db::name('category')->where('pid','-1')->update(['is_dow'=>'0']);
        $cate_pid=Db::name('category')->where('pid','<>','-1')->select();
        foreach($cate_pid as $k=>$v){
            Db::name('category')->where(['id'=>$v['pid']])->update(['is_dow'=>'1']);
        }

        $cate['id']='0';
        View::assign([
            'system'=>$system,
            'long'=>$long,
            'label'=>$label,
            'category'=>$category,
            'cate'=>$cate,
        ]);
    }

    private function getCategoryTree($pid)
    {
        $categories = Db::name('category')->where('status', 1)->where('pid', $pid)->order('sort asc, id asc')->select()->toArray();
        foreach ($categories as &$category) {
            $category['category'] = $this->getCategoryTree($category['id']);
        }
        return $categories;
    }

    /**
     * 显示警告消息并返回上一页
     * @param string $message 要显示的消息
     * @return string 包含JavaScript的HTML字符串
     */
    protected function alert_back($message)
    {
        // 使用JavaScript实现弹出警告框并返回上一页
        $script = "<script>alert('" . addslashes($message) . "'); history.back();</script>";
        
        // 直接输出并终止执行
        echo $script;
        exit;
    }


    // 获取浏览器信息
    private function getBrowser($userAgent)
    {
        if (strpos($userAgent, 'MSIE') !== false || strpos($userAgent, 'Trident') !== false) {
            return 'Internet Explorer';
        } elseif (strpos($userAgent, 'Firefox') !== false) {
            return 'Firefox';
        } elseif (strpos($userAgent, 'Chrome') !== false) {
            return 'Chrome';
        } elseif (strpos($userAgent, 'Safari') !== false) {
            return 'Safari';
        } elseif (strpos($userAgent, 'Opera') !== false || strpos($userAgent, 'OPR') !== false) {
            return 'Opera';
        } else {
            return 'Other';
        }
    }

    // 获取操作系统信息
    private function getOS($userAgent)
    {
        if (preg_match('/Windows NT 10.0/i', $userAgent)) {
            return 'Windows 10';
        } elseif (preg_match('/Windows NT 6.3/i', $userAgent)) {
            return 'Windows 8.1';
        } elseif (preg_match('/Windows NT 6.2/i', $userAgent)) {
            return 'Windows 8';
        } elseif (preg_match('/Windows NT 6.1/i', $userAgent)) {
            return 'Windows 7';
        } elseif (preg_match('/Windows NT 6.0/i', $userAgent)) {
            return 'Windows Vista';
        } elseif (preg_match('/Windows NT 5.1/i', $userAgent)) {
            return 'Windows XP';
        } elseif (preg_match('/Mac OS X/i', $userAgent)) {
            return 'Mac OS X';
        } elseif (preg_match('/Linux/i', $userAgent)) {
            return 'Linux';
        } elseif (preg_match('/iPhone/i', $userAgent)) {
            return 'iPhone';
        } elseif (preg_match('/iPad/i', $userAgent)) {
            return 'iPad';
        } elseif (preg_match('/Android/i', $userAgent)) {
            return 'Android';
        } else {
            return 'Other';
        }
    }

    // 判断当前是电脑还是手机访问
    private function getDeviceType($userAgent)
    {
        if (preg_match('/Mobile|Android|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i', $userAgent)) {
            return '手机';
        } else {
            return '电脑';
        }
    }


    

    
}